<?php
/*-----------引入檔案區--------------*/

use Xmf\Request;
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Tadtools\Utility;
use XoopsModules\Tadtools\SweetAlert;
//use XoopsModules\Tadtools\FormValidator;
//use XoopsModules\Tadtools\CkEditor;
//use XoopsModules\Tadtools\My97DatePicker;

require_once __DIR__ . '/header.php';
$xoopsOption['template_main'] = "kw_leave_book.tpl";
include_once XOOPS_ROOT_PATH . "/header.php";

/*--
學生請假簽核流程
學生簽核中列表
---*/
/*-----------執行動作判斷區----------*/
require_once $GLOBALS['xoops']->path('/modules/system/include/functions.php');
$op        = Request::getString('op');
$book_id   = Request::getInt('book_id');  //假單
$stu_id    = Request::getString('stu_id');  //申請者
$show_PageBar = Request::getBool('show_PageBar'); //頁次
// $isvalue        = Request::getInt('isvalue');
// $year      = Request::getInt('year');
$today = date('Y-m-d');

switch ($op) {

    case 'kw_leave_book_isenable':
        $isenable = Request::getInt('isenable');
        Kw_leave::kw_leave_update_isEnable('book', $book_id, $isenable);
        header("location: {$_SERVER['PHP_SELF']}");
        exit;
    case 'kw_leave_book_delete':
        kw_leave_book_delete($book_id);
        header("location: {$_SERVER['PHP_SELF']}");
        exit;
        
        
    default:
        kw_leave_book_list();
        $op = 'kw_leave_book_list';
                
}

/*-----------秀出結果區--------------*/
$xoopsTpl->assign('op', $op);
$xoopsTpl->assign("toolbar", Utility::toolbar_bootstrap($interface_menu,false,$interface_icon));
$xoopsTpl->assign('today', $today);
$xoopsTpl->assign('uid', $kw_leave_uid);
//$xoopsTpl->assign('iskwLeaveAdmin', $iskwDeviceAdmin);
//$xoopsTpl->assign('iskwLeaveCheck', $iskwDeviceCheck);
$xoTheme->addStylesheet(XOOPS_URL . '/modules/kw_leave/assets/css/module.css');
$xoTheme->addStylesheet(XOOPS_URL . '/modules/tadtools/css/vtable.css');
require_once XOOPS_ROOT_PATH . '/footer.php';


function kw_leave_book_list(){

    global $xoopsDB, $xoopsTpl, $school_grade,$school_class;
    
    $semester = kw_leave_getSemester();
    $xoopsTpl->assign('semester_arr', $semester);
    //未登入
    if( empty($_SESSION['stu_id']) || empty($_SESSION['stuID']) ){
        redirect_header('index.php', 3, _MD_KWLEAVE_UNLOGIN);
        exit;
    }
    //取得學生資料
    $stu_arr = Kw_leave::kw_leave_get_data('stu',$_SESSION['stu_id']);
    if(empty($stu_arr) ){
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NO_STU);
        exit;
    }

    $stu_id = $_SESSION['stu_id'];
    $xoopsTpl->assign('stu_id', $stu_id);
    $xoopsTpl->assign('stu', $stu_arr);
    $xoopsTpl->assign('total_days', $stu_arr['stu_total']); //總請假數
    $xoopsTpl->assign('stu_grade', $school_grade[$stu_arr['stu_grade']]);//轉成文字
    $xoopsTpl->assign('stu_class', $school_class[$stu_arr['stu_class']]);//轉成文字
    
    
    $this_year = $semester['this_year'];
    
    $year       = Request::getString('year');  //瀏覽模式
    $cate       = Request::getString('cate');  //瀏覽模式
    $isfinish   = Request::getString('isfinish');  //瀏覽模式
    
    //取得搜尋語法
    if (!empty($year)) { //no year
        if (!empty($cate)){ //假別

            if (!empty($isfinish)){
                if($isfinish == 2)//已簽核退回
                    $search = " and a.`book_isfinish`='1' and a.`book_isresult`='0' and a.`cate_id`='{$cate}' and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
                else if($isfinish == 1) //已簽核同意
                    $search = " and a.`book_isfinish`='1' and a.`book_isresult`='1' and a.`cate_id`='{$cate}' and  a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
                else if($isfinish == 3) //簽核中
                    $search = " and a.`book_isfinish`='0' and a.`cate_id`='{$cate}' and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
            }else{
                $search = " and a.`cate_id`='{$cate}' and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
            }
        }else{
            $search = " and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
        } 
    }else{
        $year = $this_year;
        $search = " and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    }
   

    //假單列表
    // $myts       = \MyTextSanitizer::getInstance();
    $sql = 'select a.*, b.* from `' . $xoopsDB->prefix('kw_leave_book') . '` as a join `' . $xoopsDB->prefix('kw_leave_img') . "` as b on a.`book_id` = b.`book_id` where a.`stu_id`='{$stu_id}' " . $search;
    //echo $sql;
    //getPageBar($原sql語法, 每頁顯示幾筆資料, 最多顯示幾個頁數選項);
    $PageBar = Utility::getPageBar($sql, 10, 20);
    $bar     = $PageBar['bar'];
    $sql     = $PageBar['sql'];
    $total   = $PageBar['total'];
    $xoopsTpl->assign('bar', $bar);
    $xoopsTpl->assign('total', $total);
    //選單
    $xoopsTpl->assign('year', $year);
    $xoopsTpl->assign('cate', $cate);
    $xoopsTpl->assign('isfinish', $isfinish);


    //取得資料庫
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    $total_num = $xoopsDB->getRowsNum($result); 
    $xoopsTpl->assign('total_num', $total_num);
    
    //取得簽核流程陣列
    $all_process_arr = Kw_leave::kw_leave_get_allTitle('process');
    $all_cate_arr    = Kw_leave::kw_leave_get_allTitle('cate');
    $all_year_arr = [$semester['this_year'],$semester['this_year']-1,$semester['this_year']-2]; //提供三年內查詢
    $xoopsTpl->assign('all_process_arr',  $all_process_arr);
    $xoopsTpl->assign('all_cate_arr',  $all_cate_arr);
    $xoopsTpl->assign('all_year_arr',  $all_year_arr);
    $all_book_content    = [];
    $i                  = 0;
    while (false !== ($all = $xoopsDB->fetchArray($result))) {
        foreach ($all as $k => $v) {
            $$k = $v;
        }
        $all_book_content[$i]['book_id']        = (int) $book_id;
        $all_book_content[$i]['book_title']     = $book_title;
        $all_book_content[$i]['book_year']      = (int) $book_year;
        $all_book_content[$i]['cate_title']     = $all_cate_arr[$cate_id];
        $json_arr = json_decode($book_json,true); //true:array, false:obj
        $all_book_content[$i]['book_desc']      = $json_arr['book_desc'];
        $all_book_content[$i]['book_num']       = $json_arr['book_num'];

        //$sign_img                               = $json_arr['sign_img'];
        if($img_type == 'upload'){
            $all_book_content[$i]['book_sign']  = "<a href='". XOOPS_URL. $img_content. "' target='_blank'><img src='". XOOPS_URL . $img_content . "'  alt='家長簽名' title='家長簽名' style='width:100px; height:50px'> </a>";
        }else if($img_type == 'sign'){
            $all_book_content[$i]['book_sign']  =  "<img src='{$img_content}'  alt='家長簽名' title='家長簽名' style='width:100px; height:50px'>";
        }
        
        $all_book_content[$i]['book_number']    = (float) $book_number;
        $all_book_content[$i]['book_dt_start']  = $book_dt_start;
        $all_book_content[$i]['book_dt_end']    = $book_dt_end;
        $all_book_content[$i]['book_dt_update'] = $book_dt_update;
        $all_book_content[$i]['book_isenable']      = (int) $book_isenable;
        $all_book_content[$i]['book_sort']       = (int) $book_sort;

        if($book_sort == '0')
            $all_book_content[$i]['book_isenable_pic']  = $book_isenable ? '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/yes.gif" alt="' . _YES . '" title="' . _YES . '">' : '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/no.gif" alt="' . _NO . '" title="' . _NO . '">';
        //是否完成
        $all_book_content[$i]['book_isresult'] = (int)$book_isresult ;
        $all_book_content[$i]['book_isfinish'] = (int)$book_isfinish ;
        $all_book_content[$i]['book_isfinish_pic'] = $book_isfinish ? '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/o.png" alt="已完成請假 " title="已完成請假" style="width:20%;height:20%">' : '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/x.png" alt="簽核中" title="簽核中" style="width:20%;height:20%" >';
        
        //取得簽核資料和家長簽名(放在班級導師簽核的'sign_json'欄位中的sign_img)
        $sign_arr= Kw_leave::kw_leave_get_data('sign','','book_id',$book_id);
        $all_book_content[$i]['sign_arr'] = $sign_arr;
        
        
        $i++;
    }

    //刪除確認的JS
    $sweet_alert_obj = new SweetAlert();
    $sweet_alert_obj->render('delete_book_func', "{$_SERVER['PHP_SELF']}?op=kw_leave_book_delete&book_id=", "book_id");

    // $xoopsTpl->assign('can_operate', true);
    // $uid = $xoopsUser ? $xoopsUser->uid() : '';
    $xoopsTpl->assign('all_book_content', $all_book_content);

}



function kw_leave_book_delete($book_id)
{
    global $xoopsDB, $iskwLeaveAdmin ;

    //檢查權限
    if (!$iskwLeaveAdmin  && empty($_SESSION['stu_id']) ) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_FORBBIDEN);
        return;
    }
    //檢查參數
    if (empty($book_id)) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_ID);
        exit;
    } else if (Kw_leave::kw_leave_book_check($book_id)) { //檢查是否已核
        redirect_header("{$_SERVER['PHP_SELF']}", 3, "此假單已經核准完成且超過請假時間，無法刪除!");
        exit;
    } else {
        //更新學生請假日數
        $book_arr = Kw_leave::kw_leave_get_data('book',$book_id );
        $sql = 'update `'.$xoopsDB->prefix('kw_leave_stu')."` SET `stu_total`=`stu_total`-{$book_arr['book_number']} WHERE `stu_id` = '{$book_arr['stu_id']}' ";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
        
        //join刪除所有相關假單(包含簽名和所有簽核)
        $sql = 'delete from `' . $xoopsDB->prefix('kw_leave_book') . "` where `book_id`='{$book_id}'; ";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
    }
}
