<?php
namespace XoopsModules\Kw_leave;
use XoopsModules\Tadtools\Utility;

// use XoopsModules\Tadtools\CkEditor;
// use XoopsModules\Tadtools\FormValidator;
// use XoopsModules\Tadtools\StarRating;
// use XoopsModules\Tadtools\SweetAlert;
// use XoopsModules\Tadtools\SyntaxHighlighter;
// use XoopsModules\Tadtools\CkEd
// use XoopsModules\Tadtools\Wcag;

/*
Update Class Definition

You may not change or alter any portion of this comment or credits of
supporting developers from this source code or any supporting source code
which is considered copyrighted (c) material of the original comment or credit
authors.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * @license      http://www.fsf.org/copyleft/gpl.html GNU public license
 * @copyright    https://xoops.org 2001-2017 &copy; XOOPS Project
 * @author       Mamba <mambax7@gmail.com>
 */

/**
 * Class kw_leave
 */
class Kw_leave
{
    public $nowtime;
    public $today;
    public $kw_leaveConfig;
    public $kw_leaveModule;
    public $UpFiles;
    public $DataCenter;
    
    private $module_id;
    private $uid;
    private $groups = [];
    

    //建構函數
    public function __construct($uid = null, $groups = null)
    {
        global $xoopsConfig, $xoopsUser;

        //xoops_loadLanguage('main', 'kw_leave');

        // $this->nowtime = date('Y-m-d H:i:s', xoops_getUserTimestamp(time()));
        // $this->today = date('Y-m-d', xoops_getUserTimestamp(time()));

        // $moduleHandler = xoops_getHandler('module');
        // $this->kw_leaveModule = $moduleHandler->getByDirname('kw_leave');
        // $this->module_id = $this->kw_leaveModule->mid();
        // $configHandler = xoops_getHandler('config');
        // $this->kw_leaveConfig = $configHandler->getConfigsByCat(0, $this->module_id);

        // if (!is_null($uid)) {
        //     $this->uid = $uid;
        // } elseif ($xoopsUser) {
        //     $this->uid = $xoopsUser->uid();
        // }

        // if (!is_null($groups)) {
        //     $this->groups = $groups;
        // } elseif ($xoopsUser) {
        //     $this->groups = $xoopsUser->getGroups();
        // }
    }

    //取得所有uid資料(四種模式：uid_arr,user_arr,noMaster_arr, all)
    /**
     * @param type
     * @return array(user_arr, uid_arr, noMaster_arr, master_arr);
     */
    public static function kw_leave_get_users($type = '')
    {
        global $xoopsDB;
        $sql = 'select `uid`, `name`, `uname` from ' . $xoopsDB->prefix('users') . ' order by uname';
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $i = 0;
        $user_arr=[];
        $uid_arr=[];
        if($type == 'noMaster_arr' or empty($type)){
            $master_arr = kw_leave::kw_leave_get_masters(); //[uid]=[name,uname]
        }
        while (list($uid, $name, $uname) = $xoopsDB->fetchRow($result)) {
            if($type == 'user_arr' or  empty($type)){
                $user_arr[$i]['uid'] = $uid;
                $user_arr[$i]['name'] = $name;
                $user_arr[$i]['uname'] = $uname;
            }
            if ($type == 'uid_arr' or  empty($type)){
                $uid_arr[$uid] = $name;
            }
            if (($type == 'noMaster_arr' or empty($type) ) && !in_array($uname, array_column($master_arr,'uname')) ) {
                $noMaster_arr[$uid] = array('name'=>$name, 'uname'=>$uname);
            }
            $i++;
        }
        if($type == 'uid_arr'){
            return $uid_arr;
        }else if($type == 'user_arr'){
            return $user_arr;
        }else if($type == 'noMaster_arr'){
            return array($noMaster_arr, $master_arr);
        }else{
            return array($user_arr,$uid_arr, $noMaster_arr, $master_arr);
        }
    }


    public static function kw_leave_get_userByUid($uid)
    {
        global $xoopsDB;
        $sql = 'select `uname`, `name` from ' . $xoopsDB->prefix('users') . " where `uid`='{$uid}' ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($uname, $name) = $xoopsDB->fetchRow($result);
        return array('uname'=>$uname,'name'=>$name);
    }
    
    /**
     * 設定管理階層uid
     * @param $group_name
     * @return $groupid 
     */
    public static function kw_leave_groupID($group_name = '')
    {
        global $xoopsDB;
        $sql = 'select `groupid` from ' . $xoopsDB->prefix('groups') . " where `name`='{$group_name}'";
        $result = $xoopsDB->queryF($sql) or Utility::web_error($sql);
        list($groupid) = $xoopsDB->fetchRow($result);
        if (empty($groupid)) {//新增'導師群組'
            $name = _MI_KWLEAVE_MASTER_GROUP;
            $description =_MI_KWLEAVE_MASTER_GROUP . _MI_KWLEAVE_GROUP_NOTE;
            $sql = 'insert into ' . $xoopsDB->prefix('groups') . " (`name`, `description`,`gropu_type`) values('{$name}','{$description}','Teachers')";
            $xoopsDB->queryF($sql) or Utility::web_error($sql);
            //取得最後新增資料的流水編號
            $groupid = $xoopsDB->getInsertId();
        }
        return $groupid;
    }
    
    /**
     * 取得教師群組uid
     * @param 
     * @return $master_arr[uid]=[name=>name,uname=>uname]
     */
    public static function kw_leave_get_masters()
    {
        $groupid = Kw_leave::kw_leave_groupID(_MD_KWLEAVE_MASTER_GROUP);
        $master_arr = [];
        //列出群組中有哪些人
        if ($groupid) {
            /* @var \XoopsMemberHandler $memberHandler */
            $memberHandler = xoops_getHandler('member');
            $master_arr    = $memberHandler->getUsersByGroup($groupid);
        }
        // print_r($master_arr);
        $masters=[];
        foreach($master_arr as $v){ //all uid for a group
            $masters[$v] =  Kw_leave::kw_leave_get_userByUid($v);
        }
        // var_dump($masters);
        return $masters;
    }


    //以ID取得單筆資料、取得所有資料、取得欄位值對應資料
    /**
     * @param $dbName
     * @param $Id、$field、$value
     * @return $data[_id][all]
     */
    public static function kw_leave_get_data($dbName, $Id = '', $field = '', $value = '')
    {
        global $xoopsDB;
        if (empty($dbName)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_FIELD);
            exit;
        }

        if (!empty($Id)) //用id取得資料
        {
            $sql = 'select * from `' .  $xoopsDB->prefix('kw_leave_' . $dbName) . "`  where `{$dbName}_id` = '{$Id}'";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            $data = $xoopsDB->fetchArray($result);
            
        } else if (!empty($field) && !empty($value)) { //return data[id]= 條件符合的資料 

            $sql = 'select * from `' .  $xoopsDB->prefix('kw_leave_' . $dbName) . "`  where `{$field}` = '{$value}'";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            $data = [];
            $i = 0;
            while (false !== ($all = $xoopsDB->fetchArray($result))) {
                $data[$i] = $all;
                $i++;
            }
        } else  //取得多筆資料 return data[id]= all                             
        {
            $sql = 'select * from `' .  $xoopsDB->prefix('kw_leave_' . $dbName) . "` order by {$dbName}_sort";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            $data = [];
            $i = 0;
            while (false !== ($all = $xoopsDB->fetchArray($result))) {
                if(isset($all["{$dbName}_isenable"])){
                    $isenable = $all["{$dbName}_isenable"];
                    $all["{$dbName}_isenable_pic"] = $isenable ? '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/yes.gif" alt="' . _YES . '" title="' . _YES . '">' : '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/no.gif" alt="' . _NO . '" title="' . _NO . '">';
                }
                $data[$all[$dbName . '_id']] = $all;
                $i++;
            }
        }
        return $data;
    }

    //取得所有enable的Title資料
    /**
     * @param $dbName
     * @return $data[$id]=$title
     */
    public static function kw_leave_get_allTitle($dbName)
    {
        global $xoopsDB, $allDB;
        if (!in_array($dbName, $allDB)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_FIELD);
            exit;
        }
        $sql = "select `{$dbName}_id`, `{$dbName}_title` from `" . $xoopsDB->prefix('kw_leave_' . $dbName) . "` where  `{$dbName}_isenable`='1' order by `{$dbName}_sort`";
        // echo $sql;
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = [];
        while (list($Id, $Title) = $xoopsDB->fetchRow($result)) {
            $data[$Id] = $Title;
        }
        return $data;
    }


   

     //以ID取得單筆資料欄位值對應資料
    /**
     * @param $dbName、$Id、$field
     * @return $data []
     */
    public static function kw_leave_get_fieldById($dbName, $Id , $field){
        global $xoopsDB;
        $data=[];
        if (empty($dbName) or !isset($Id) or empty($field)) {
            redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_NEED_ID);
            exit;
        }
        $sql = "select `{$field}` from `" . $xoopsDB->prefix('kw_leave_' . $dbName) . "` where `{$dbName}_id` = '{$Id}'";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = $xoopsDB->fetchArray($result);
        return $data;
    }
     //以uid取得欄位(唯一)
    /**
     * @param $dbName, $uid, $field 
     * @return mix $arr []
     */
    public static function kw_leave_get_fieldByUid($dbName, $uid, $field)
    {
        global $xoopsDB;
        if (empty($dbName) || !isset($uid) ||empty($field)) {
            redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_NEED_FIELD);
            exit;
        }
        if($field == '*')
            $sql = "select * from `" . $xoopsDB->prefix('kw_leave_' . $dbName) . "`  where `{$dbName}_uid` = '{$uid}'";
        else
            $sql = "select `{$field}` from `" . $xoopsDB->prefix('kw_leave_' . $dbName) . "`  where `{$dbName}_uid` = '{$uid}'";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = $xoopsDB->fetchArray($result);
        return $data;
    }

     //以UID取得欄位對應資料(不唯一)
    /**
     * @param $dbName、$Uid、$field
     * @return $arr []
     */
    public static function kw_leave_get_dataByUid($Uid , $type){
        global $xoopsDB;
        $data=[];
        if (empty($type) or !isset($Uid) ) {
            redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_NEED_FIELD);
            exit;
        }
        if($type == 'teacher'){
            $sql = "select * from `" . $xoopsDB->prefix('kw_leave_class') . "` where `class_teacher_uid` = '{$Uid}' and `class_isenable`='1'";
            // echo $sql;
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            $data = $xoopsDB->fetchArray($result);
            return $data;

        }else if($type== 'backup'){
            $sql = "select * from `" . $xoopsDB->prefix('kw_leave_process') . "` where `process_backup_uid` = '{$Uid}' and `process_isenable`='1'";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            $arr=[];
            while ($data = $xoopsDB->fetchArray($result)) {
                $arr[] = $data;
            }
            return $arr;
        }
    }

      //以ID取得單筆資料欄位值對應資料
    /**
     * @param $uid,type(正職 or 職代)
     * @return $process_sort
     */
    public static function kw_leave_get_sort($Uid, $type ='' ){
        global $xoopsDB;

        if( !isset($Uid) ) {
            redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_NEED_FIELD);
            exit;
        }
        if($type == 'backup'){
            $sql = 'select `process_sort` from `' . $xoopsDB->prefix('kw_leave_process'). "` where `process_backup_uid`='{$Uid}' and `process_isenable`='1'";
        }
        else{//簽核序
            $sql = 'select `process_sort` from `' . $xoopsDB->prefix('kw_leave_process'). "` where `process_uid`='{$Uid}' and `process_isenable`='1'";
        }
        
        $arr=[];
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        // echo $sql;
        while (list($data) = $xoopsDB->fetchRow($result)) {
            $arr[] = $data;
        }
        
        return $arr;
    }
    //檢查班級學生資料筆數
    /**
     * dbName:stu
     * @return array classNum_arr[class_id]=class_num (各班班級數)
     */
    public static function kw_leave_get_stuCheck()
    {
        global $xoopsDB,$allDB;
        // SELECT COUNT(DISTINCT (class_id ),stu_id) FROM xx_kw_leave_stu;
        $sql = "select distinct (`class_id`) from  `" . $xoopsDB->prefix('kw_leave_stu') . "` ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $classID_arr = [];
        while (list($id) = $xoopsDB->fetchRow($result)) {
            $classID_arr[] = $id;
        }
        
        $classNum_arr=[];
        foreach($classID_arr as $cid){
            $sql = "select count(`stu_id`) from `" . $xoopsDB->prefix('kw_leave_stu') . "` where `class_id` = {$cid}";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            list($count) = $xoopsDB->fetchRow($result);
            $classNum_arr[$cid] = $count;
        }
        // var_dump($classNum_arr);
        return $classNum_arr;
    }


    //取得所有uid資料
    /**
     * @param $process_id
     * @return $data[$id]=$uid
     */
    public static function kw_leave_get_processUid($process_id = '')
    {
        global $xoopsDB;
        if (!empty($process_id)) {
            $sql = "select  `process_uid` from `" . $xoopsDB->prefix('kw_leave_process') . "` where  `process_id` = '" . $process_id . "'  and  `process_isenable`='1' ";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            list($uid) = $xoopsDB->fetchRow($result);
            $data = $uid;
        } else {
            $sql = "select `process_id`, `process_uid` from `" . $xoopsDB->prefix('kw_leave_process') . "` where  `process_isenable`='1' ";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            $data = [];
            while (list($Id, $uid) = $xoopsDB->fetchRow($result)) {
                $data[$Id] = $uid;
            }
        }
        return $data;
    }
    
    
    //檢查uid資料
    /**
     * @param $uid
     * @return Bool
     */
    public static function kw_leave_check_uid($dbName, $uid)
    {
        global $xoopsDB;
        if (empty($dbName) or empty($uid)){
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_FIELD);
            exit;
        }
        $sql = "select count(`{$dbName}_uid`) from `" . $xoopsDB->prefix('kw_leave_'.$dbName) . "` where `{$dbName}_uid`='{$uid}'";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($num) = $xoopsDB->fetchRow($result);
        if ($num >0)
            return true;
        else
            return false;
    }


    /**
     * 更新啟用或停用
     * @param $dbName, $Id,$isEnable
     * @return bool
     */
    public static function kw_leave_update_isEnable($dbName, $Id, $isEnable)
    {
        global $xoopsDB, $iskwLeaveAdmin, $iskwLeaveCheck;
        //檢查權限
        if (!$iskwLeaveAdmin && !$iskwLeaveCheck &&  !$this->uid) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_FORBBIDEN);
            exit;
        }
        else{
            $sql = 'update `' . $xoopsDB->prefix('kw_leave_' . $dbName) . "` set
            `{$dbName}_isenable` = '{$isEnable}' where `{$dbName}_id` = '$Id'";
            $xoopsDB->queryF($sql) or Utility::web_error($sql);
            // echo $sql;
            return true;
        }
    }

    //檢查book是否已簽核完成(不可刪除)
    public static function kw_leave_book_check($book_id){
        global $xoopsDB;
        if(!isset($book_id)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_ID);
            exit;
        }else {
            $sql = 'select count(*) from `' . $xoopsDB->prefix('kw_leave_book') . "`  where `book_isfinish` ='1' and `book_isresult` ='1' and `book_id` = '{$book_id}'";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            list($count) = $xoopsDB->fetchRow($result);
            return $count > 0 ? true : false;
        }
        
    }

    //檢查sign是否已有簽核(不可編輯)
    public static function kw_leave_sign_check($Id)
    {
        global $xoopsDB;
        if ( !isset($Id)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_ID);
            exit;
        }else {
            $sql = 'select count(*) from `' . $xoopsDB->prefix('kw_leave_sign') . "`  where `sign_time`<> NULL and `book_id` = '{$Id}'";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            list($count) = $xoopsDB->fetchRow($result);
            return $count > 0 ? true : false;
        }
        
    }

    //檢查表格刪除相依性資訊FOREIGN KEY設定
    //刪除office時檢查process
    //刪除cate時檢查book
    //刪除process時檢查sign(sort)
    //刪除book時，連動刪除sign
    //刪除stu時，連動刪除book+sign
    /**
     * @param $dbName, $ID
     * @return true or error msg
     */
    // public static function kw_leave_delete_check( $dbName, $Id)
    // {
    //     global $xoopsDB;
    //     if (empty($dbName) or !isset($Id)) {
    //         redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_FIELD);
    //         exit;
    //     }else {
    //         $sql = 'select count(*) from `' . $xoopsDB->prefix('kw_leave_' . $dbName) . "`  where `sign_time`<> NULL and `{$dbName}_id` = '{$Id}'";
    //         $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    //         list($count) = $xoopsDB->fetchRow($result);
    //         return $count > 0 ? true : false;
    //     }
        
    // }

    /**
     * 上傳img檔案並存到指定位置
     * @param $dbName, $book_id
     * @return true or false
     */
    public static function kw_leave_imgUpload($book_id){
        global $xoopsDB;
        if (empty($book_id)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_ID);
            exit;
        }
        $path = XOOPS_ROOT_PATH."/uploads/kw_leave/book";

        // 檢查檔案是否上傳成功
        if ($_FILES['file']['error'] === UPLOAD_ERR_OK) {
            if (!is_dir( $path )) {
                mkdir( $path);
            }
            // 暫存檔來源
            $file = $_FILES['file']['tmp_name'];
            $filename = $_FILES['file']['name'];
            
            // 副檔名檢查
            $ext = pathinfo($filename, PATHINFO_EXTENSION);
            // echo $ext;
            if ($ext != 'png' && $ext != 'jpg' && $ext != 'jpeg') {
                // die('請上傳影像格式的檔案');
                redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_UPLOAD_EXT);
                exit;
            }
            $newName = $book_id.".".$ext;
            $dest = $path ."/".$newName;
            
            // 將檔案移至指定位置
            if (!move_uploaded_file($file, $dest)) {
                // die("無法將檔案{$file}上傳至指定位置{$dest}");
                redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_UPLOAD_ERROR);
                exit;
            }
        } else {
            // die("上傳錯誤：{$_FILES['class_file']['error']}");
            redirect_header("{$_SERVER['PHP_SELF']}", 3, $_FILES['class_file']['error']);
            exit;
        }
        
        $sql = "SELECT `img_id` from `". $xoopsDB->prefix('kw_leave_img'). "` where `book_id` ='{$book_id}'";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($img_id) = $xoopsDB->fetchRow($result);

        $type = 'upload'; 
        $img_path = "/uploads/kw_leave/book/".$newName;

        if($img_id){ //更新
            $sql = "UPDATE `". $xoopsDB->prefix('kw_leave_img'). "`  SET  `img_type`='{$type}', `img_content`='{$img_path}', `img_date`=NOW() where `book_id`='{$book_id}' and `img_id`='{$img_id}'";
            $xoopsDB->query($sql) or Utility::web_error($sql);
            // $sn = $img_id;
        }else{ //新增
            $sql = "INSERT INTO `". $xoopsDB->prefix('kw_leave_img'). "` (`book_id`, `img_type`, `img_content`,`img_date`) VALUES ('{$book_id}','{$type}', '{$img_path}', NOW())";
            $xoopsDB->query($sql) or Utility::web_error($sql);
            // $sn =$xoopsDB->getInsertId();
        }
    }

    /**
     * img檔案並存到資料庫
     * @param $book_id
     * @return true or false
     */
    public static function kw_leave_imgSigned($book_id ,$img){
        global $xoopsDB;
        if (empty($book_id) || empty($img)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_ID);
            exit;
        }
        
        $sql = "SELECT `img_id` from `". $xoopsDB->prefix('kw_leave_img'). "` where `book_id` ='{$book_id}'";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($img_id) = $xoopsDB->fetchRow($result);

        $type = 'sign'; 
        if($img_id){ //更新簽名
            $sql = "UPDATE `". $xoopsDB->prefix('kw_leave_img'). "`  SET  `img_type`='{$type}', `img_content`='{$img}', `img_date`=NOW() where `book_id`='{$book_id}' and `img_id`='{$img_id}'";
            $xoopsDB->query($sql) or Utility::web_error($sql);
            // $sn = $img_id;
        }else{
            $sql = "INSERT INTO `". $xoopsDB->prefix('kw_leave_img'). "` (`book_id`, `img_type`, `img_content`,`img_date`) VALUES ('{$book_id}','{$type}', '{$img}', NOW() )";
            $xoopsDB->query($sql) or Utility::web_error($sql);
            //$xoopsDB->getInsertId();
        }
    }


    /**
     * 上傳csv檔案並存到指定位置
     * @param $dbName
     * @return true or false
     */
    public static function kw_leave_upload($dbName){
        global $xoopsDB,$allDB;
        
        if (!in_array($dbName, $allDB)) {
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_FIELD_ERROR);
            exit;
        }
        $path = XOOPS_ROOT_PATH."/uploads/kw_leave/{$dbName}";
        // 檢查檔案是否上傳成功
        if ($_FILES['file']['error'] === UPLOAD_ERR_OK) {
            if (!is_dir( $path )) {
                mkdir( $path);
            }
            // 暫存檔來源
            $size = $_FILES['file']['size'];
            $file = $_FILES['file']['tmp_name'];
            $filename = $_FILES['file']['name'];
            
            
            // 副檔名檢查
            $ext = pathinfo($filename, PATHINFO_EXTENSION);
            if ($ext != 'csv') {
                // die('請上傳csv格式的檔案');
                // redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_UPLOAD_EXT);
                // exit;
                // $json = '{"status":0, "content":"檔案格式錯誤!"}';
                // return $json;
                $msg ="檔案格式錯誤!";
                return [false,$msg];
            }
            $newname = date('YmdHis');
            $dest = $path ."/{$newname}.{$ext}";
            
            // 將檔案移至指定位置
            if (!move_uploaded_file($file, $dest)) {
                // die("無法將檔案{$file}上傳至指定位置{$dest}");
                // redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_UPLOAD_ERROR);
                // exit;
                // $json='{"status":0, "content":"移動檔案錯誤!"}';
                // return $json;
                $msg ="移動檔案錯誤!";
                return [false,$msg];
            }
            //以下是匯入資料
            $i = 0;
            $line_list=[];
            $field=[];
            if($dbName == 'class'){
                $uid_arr = kw_leave::kw_leave_get_users('uid_arr'); //導師列表[uid]=[姓名,帳號]
            }
            if (($handle = fopen($dest, "r")) !== FALSE) {
                while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                    $num = count($data); 
                    if($num != 8 ){
                        //redirect_header("{$_SERVER['PHP_SELF']}", 3, "資料欄位錯誤!");
                        // echo "<script>alert('資料欄位錯誤!');</script>";
                        // exit;
                        $msg ="資料欄位錯誤!";
                        return [false,$msg];
                    }

                    if ($i == 0) { //csv第一行標題
                        $field = $data; //欄位
                        //新增第九欄(index=8)
                        $dbName=='class' ? $field[$num]= 'class_teacher_uid': $field[$num]= 'stu_total';
                        $data = mb_convert_encoding($data, "UTF-8", 'BIG5');
                        // echo $num."data_field:".$data[0]."<br>";

                    }else if($i>1){ //csv從第三列開始讀
                        for($j=0 ; $j< $num ;$j++){//判断是否是UTF-8，不是就轉換
                            // if( mb_detect_encoding($data[$j],"UTF-8") != "UTF-8" )
                            $data[$j] = iconv('BIG5', 'UTF-8//IGNORE', $data[$j]);
                        }
                        if($dbName == 'class'){
                            //轉換教師姓名取得uid 
                            $data[$num] = array_search($data[5], $uid_arr); //最後一欄位的值
                            //$data[] ="{\"class_teacher\":\"{$data[5]}\"}";
                            if(empty($data[$num])){
                                $msg ="教師姓名錯誤!查無此人!";
                                return [false,$msg];
                            }
                            // var_dump($uid_arr);
                        }else{
                            $data[$num] = 0; //stu_total
                        }
                        //checking data exited
                        $sql = 'select count(*) from `' . $xoopsDB->prefix('kw_leave_' . $dbName) . "`  where `{$dbName}_id` = '{$data[0]}'";
                        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
                        list($rows) = $xoopsDB->fetchRow($result);
                        $index = '';
                        $value = '';

                        if($rows > 0 ){ //update
                            $sql = 'update `' .$xoopsDB->prefix('kw_leave_' . $dbName). "` set ";
                            foreach($data as $k=>$v){
                                if($k!=0)
                                    $sql=$sql."`{$field[$k]}` = '{$v}', ";
                                if ($k==$num)
                                    $sql=$sql."`{$field[$k]}` = '{$v}' ";
                            } 
                            $sql=$sql." where `{$dbName}_id` = '{$data[0]}'";
                            
                        }else{//insert
                            $sql = 'insert into `'.$xoopsDB->prefix("kw_leave_".$dbName)."` ("; 
                            foreach($data as $k=>$v){
                                if ($k==$num){
                                    $index = $index."`{$field[$k]}` ) values(";
                                    $value = $value. "'{$v}' )";
                                }else{
                                    $index = $index."`{$field[$k]}`, ";
                                    $value = $value. "'{$v}', ";
                                }
                            }
                            $sql= $sql.$index.$value;
                        }
                        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
                        $line_list[] = $data;
                    }
                    // echo $sql."<br>";
                    // if($i%10==0)
                    //     echo '{progress:"'.$i.'"}';
                    $i++;
                }
                fclose($handle);
            }//end if
        } else {
            // die("上傳錯誤：{$_FILES['class_file']['error']}");
            // redirect_header("{$_SERVER['PHP_SELF']}#setupTab6", 3, _MD_KWLEAVE_UPLOAD_ERROR);
            // exit;
            // $json = '{"status":0, "content":"上傳檔案錯誤!"}';
            // return $json;
            $msg ="上傳檔案錯誤!";
            return [false,$msg];
        }
        // $json = '{"status":1,"name":"'.$filename.'","url":"'.$dest.'","size":"'.$size.'","content":"上傳成功"}';
        // return $json;
        $msg ="上傳成功";
        return [true,$msg];
    }

}

