<?php
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Tadtools\Utility;

//檢查是否具有審核權限
function kw_leave_isCheck($uid)
{
    global $xoopsUser, $xoopsDB, $iskwLeaveAdmin;

    if ($xoopsUser) {
        if ($iskwLeaveAdmin) {
            return true;
        }
        $sql = "select count(`process_id`) from `" . $xoopsDB->prefix("kw_leave_process") . "` where (`process_uid`='" . $uid . "' or `process_backup_uid`='" . $uid . "') and `process_isenable` ='1' ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($num) = $xoopsDB->fetchRow($result);
        if ($num > 0) { //可能身兼2個
            return true;
        }
        else{
            return false;        
        }
    }
    return false;
}
//
function kw_leave_isMaster($uid)
{
    global $xoopsUser, $xoopsDB;
    
    if(!empty($uid)){ //檢查是否是導師
        $sql = "select count(`class_teacher_uid`) from `" . $xoopsDB->prefix("kw_leave_class") . "` where `class_teacher_uid`='" . $uid . "'; ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($num) = $xoopsDB->fetchRow($result);
        if($num == 0){
             //檢查是否是導師群組權限
            if ($xoopsUser) {
                $my_groups = $xoopsUser->groups(); //取得user 所有所屬的group_id
                $master_group_id = Kw_leave::kw_leave_groupID(_MD_KWLEAVE_MASTER_GROUP);
                return in_array( $master_group_id , $my_groups )? true:false;
            } 
        }
        // return $num > 0 ? true : false;
        return true;
    }
    return false;
}


//檢查是否具有請假權限
function kw_leave_isBook()
{
    global $xoopsDB, $iskwLeaveAdmin;
    if ($iskwLeaveAdmin) {
        return true;
    }
    //檢查是否是學生 (不須登入)
    $sql = "select `stu_uid` from `" . $xoopsDB->prefix("kw_leave_stu") . "` where `stu_id`='" . $_SESSION['stu_id'] . "'; ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($stu) = $xoopsDB->fetchRow($result);
    return $stu ? true : false;
}

//get client ip
/**
 * @return ip
 */
function kw_leave_getIp()
{
    $ip = '';
    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    }
    if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        $ips = explode(', ', $_SERVER['HTTP_X_FORWARDED_FOR']);
        if ($ip) {
            array_unshift($ips, $ip);
            $ip = false;
        }
        foreach ($ips as $i => $iValue) {
            if (!preg_match("#^(10|172\.16|192\.168)\.#i", $ips[$i])) {
                $ip = $iValue;
                break;
            }
        }
    }
    return ($ip ?: $_SERVER['REMOTE_ADDR']);
}


//回傳class_id  1 101 201
/**
 * @return $semester = [ ]
 */
function kw_leave_getClassID($grade, $class){
    if (!isset($grade) || !isset($class)) {
        return false;
    }
    if($grade==0){
        $class_id = $class;
    }
    else if($grade<10){
        $class_id = (int) $class>9 ? $grade.$class : $grade.'0'.$class ;
    }
    return $class_id;
}

//判斷學年度
/**
 * @return $semester = [ ]
 */
function  kw_leave_getSemester()
{
    global $xoopsModuleConfig;
    //semester and year
    $arr_time  = getdate();
    list($school_limit_start,$school_limit_end) = explode(";",$xoopsModuleConfig['school_limit']);  //偏好設定
    // $this_week = $arr_time['wday'];

    if ($arr_time['mon'] >= 2 && $arr_time['mon'] <= 7) { // 2-7 (第二學期)
        $this_semester = '02';
        $this_year     = $arr_time['year'] - 1912; //學年度
        $semester = [
            'year' => $this_year . $this_semester,
            'this_year' => $this_year, //學年度
            'this_dcyear' => $this_year + 1911,
            'this_semester' => $this_semester,
            'start_date' => $this_year + 1 . '-02-01',
            'end_date' => $this_year + 1 . '-07-31',
            'start_date_dc' => $this_year + 1912 . '-02-01',
            'end_date_dc' => $this_year + 1912 . '-07-31',
            'start_dt_dc' => $this_year + 1911 . '-08-01',
            'end_dt_dc' => $this_year + 1912 . '-07-31',
            'school_limit_start' =>$school_limit_start,
            'school_limit_end' =>$school_limit_end
        ];
    } elseif ($arr_time['mon'] >= 8 && $arr_time['mon'] <= 12) { //8-12 (第一學期)
        $this_semester = '01';
        $this_year     = $arr_time['year'] - 1911; //學年度
        $semester = [
            'year' => $this_year . $this_semester,
            'this_year' => $this_year, //學年度
            'this_dcyear' => $this_year + 1911,
            'this_semester' => $this_semester,
            'start_date' => $this_year . '-08-01',
            'end_date' => $this_year + 1 . '-01-31',
            'start_date_dc' => $this_year + 1911 . '-08-01',
            'end_date_dc' => $this_year + 1912 . '-01-31',
            'start_dt_dc' => $this_year + 1911 . '-08-01',
            'end_dt_dc' => $this_year + 1912 . '-07-31',
            'school_limit_start' =>$school_limit_start,
            'school_limit_end' =>$school_limit_end
        ];
    } elseif ($arr_time['mon'] == 1) { //01 (第一學期)
        $this_semester = '01';
        $this_year     = $arr_time['year'] - 1912; //學年度
        $semester = [
            'year' => $this_year . $this_semester,
            'this_year' => $this_year, //學年度
            'this_dcyear' => $this_year + 1911,
            'this_semester' => $this_semester,
            'start_date' => $this_year . '-08-01',
            'end_date' => $this_year + 1 . '-01-31',
            'start_date_dc' => $this_year + 1911 . '-08-01',
            'end_date_dc' => $this_year + 1912 . '-01-31',
            'start_dt_dc' => $this_year + 1911 . '-08-01',
            'end_dt_dc' => $this_year + 1912 . '-07-31',
            'school_limit_start' =>$school_limit_start,
            'school_limit_end' =>$school_limit_end
        ];
    }
    return $semester;
}


//檢查請假節數正確性
/**
 * @param $start, $end (int)
 * @return $array[$float, $str]
 */
function kw_leave_chk_class($start, $end){
    global $school_time;
     //取得學校設定請假起訖
    $semester = kw_leave_getSemester();
    $limit_start = date_create($semester['school_limit_start']);
    $limit_end = date_create($semester['school_limit_end']);
    $limit_interval = $limit_start->diff($limit_end);
    $school_interval = (int)$limit_interval->format("%H");

    if( $start > $end || empty($start) || empty($end) ||empty($school_time[$start]) || empty($school_time[$end]) ){
        return false;
    }
    $hours = (int)$end-$start+1;
    $hours = round($hours / $school_interval, 1 );
    return array($hours, "{$hours}時");
}

//檢查時間是否已申請過
/**
 * @param $stu_id, $start, $end (datetime)
 * @return $array[$float, $str]
 */
function kw_leave_time_isRepeat($stu_id, $start, $end, $book_id=''){
    global $xoopsDB;

    if(!empty($book_id))
        $sql = "SELECT `book_dt_start`, `book_dt_end` FROM `".$xoopsDB->prefix('kw_leave_book')."` WHERE `stu_id`='{$stu_id}' and `book_id`<>'{$book_id}' ";
    else
        $sql = "SELECT `book_dt_start`, `book_dt_end` FROM `".$xoopsDB->prefix('kw_leave_book')."` WHERE `stu_id`='{$stu_id}' ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    $all_books = [];
    $i = 0;
    while (false !== ( list($s,$e) = $xoopsDB->fetchRow($result))) {
        if( ($s<=$start && $start<=$e) || ($s<=$end && $end<=$e) || 
            ($start<=$s && $e<=$end) || ($s<=$start && $end<=$e)){
            return true;
        }
    }
    return false;
}
//檢查時間正確性
/**
 *  @param $start, $end (datetime)
 * @return $array[$float, $str]
 */
function kw_leave_chk_time($start, $end)
{   
    global $workDate_path,$restDate_path;

    $start = date_create($start);
    $end = date_create($end);
    $float_days = 0.0;
    $str_days="";
    $start_date = $start->format("Y-m-d");
    $start_time = $start->format("H:i:s");
    $end_date = $end->format("Y-m-d");
    $end_time = $end->format("H:i:s");
    $semester = kw_leave_getSemester();
    $workDate_arr = json_decode(file_get_contents($workDate_path), true);
    $restDate_arr = json_decode(file_get_contents($restDate_path), true);
    //檢查日期是否合法
    if( $start_date > $end_date || $start_date < $semester['start_dt_dc']  || $end_date >  $semester['end_dt_dc'] || empty($start) || empty($end) ){
        redirect_header($_SERVER['HTTP_REFERER'], 3, _MD_KWLEAVE_DATE_ERROR); //日期錯誤
        exit;
    }

    //檢查日期是否為假日
    if( date('w', strtotime($start_date))%6==0 && 
        !in_array(date("m-d", strtotime($start_date)),$workDate_arr)){ //日期是星期六日且不是工作日
        redirect_header($_SERVER['HTTP_REFERER'], 3, _MD_KWLEAVE_DATE_REST); 
        exit;
    }
    if( date('w', strtotime($end_date))%6==0 && 
        !in_array(date("m-d", strtotime($end_date)), $workDate_arr)){ //日期是星期六日且不是工作日        
        redirect_header($_SERVER['HTTP_REFERER'], 3, _MD_KWLEAVE_DATE_REST); 
        exit;
    }
    if( in_array(date('m-d', strtotime($start_date)), $restDate_arr) ||  //日期是假日
        in_array(date('m-d', strtotime($end_date)), $restDate_arr)){
        redirect_header($_SERVER['HTTP_REFERER'], 3, _MD_KWLEAVE_DATE_REST); 
        exit;
    }
    //die(date('m-d', strtotime($start_date)).",".date('m-d', strtotime($end_date)));
    //檢查時間是否超出學校指定範圍
    if( $start_time < $semester['school_limit_start'] ||
        $start_time >= $semester['school_limit_end'] || 
        $end_time > $semester['school_limit_end'] || 
        $end_time <= $semester['school_limit_start'] || 
        empty($start_time) || empty($end_time) ){
        //die($start_time . $end_time .$semester['school_limit_start'].$semester['school_limit_end'] );
        redirect_header($_SERVER['HTTP_REFERER'], 3, _MD_KWLEAVE_DATE_ERROR); //日期錯誤
        exit;
    }
    //取得學校設定請假起訖
    $limit_start = new DateTime($semester['school_limit_start']);
    $limit_end = new DateTime($semester['school_limit_end']);
    $limit_interval = $limit_start->diff($limit_end);
    $school_interval = (int)$limit_interval->format("%H");
    // die("school_interval".$school_interval);
    //計算天數
    $origin_date = date_create($start_date);
    $target_date = date_create($end_date);
    $origin_time = date_create($start_time);
    $target_time = date_create($end_time);
    $interval = $origin_date->diff($target_date);//日期差string
    $days = (int)$interval->format("%a") ; //日(日差=end-start)
    //die("interval days".$days);

    if($days == 0){ //同日
        $interval = $origin_time ->diff($target_time);
        $hours =(int)$interval->format("%H"); //時
        $float_days = round($hours/ $school_interval , 1) ;//無條件進位
        $str_days = ($hours >= $school_interval) ? "1日" : "{$hours}時";
    }else{ //超過1天以上
        $i = $days;
        //計算工作日數
        while($i>=1){ //檢查中間幾日是否是工作日
            $w = date('w', strtotime("+{$i} day", strtotime($start_date)));//星期 0-6
            $d = date('m-d', strtotime("+{$i} day", strtotime($start_date))); //日期'02-18'
            //假日
            if($w%6==0 && !in_array($d ,$workDate_arr))//(星期六或日)且非工作日，遇到要扣除
                {$days--; }
            //檢查節假日，遇到要扣除
            if(in_array($d,$restDate_arr))//節假日
                {$days--;}
            $i--;
        }
        //計算時間
        $interval = $origin_time->diff($limit_end);
        $hour_1 =(int)$interval->format("%H");
        $interval = $limit_start->diff($target_time);
        $hour_2 =(int)$interval->format("%H");
        $hours = ($hour_1+$hour_2);

        if($hours%$school_interval == 0){ //處理剛好日的情況 
            if($hours > $school_interval) $days++;
            $float_days = $days;	
            $str_days = "{$days}日";
        }
        else if( $hours < $school_interval){ //處理不到一日(8時)的情況
            $days--;
            $float_days = $days + round($hours/ $school_interval, 1 );
            $str_days = ($days==0) ? "{$hours}時" : "{$days}日{$hours}時";
        }else{ //處理超過1日不滿2日
            $hour = (int) $hours % $school_interval;
            $float_days = $days + round($hour/$school_interval,1);//	
            $str_days = "{$days}日{$hour}時";
        }
    }
    //echo $float_days."-".$str_days;
    return array($float_days, $str_days);

}


//取得排序最大值
/**
 * @param $dbName
 * @return $sort_max
 */
function kw_leave_max_sort($dbName, $type='')
{
    global $xoopsDB, $allDB;
    if (!in_array($dbName,$allDB)) {
        return false;
    }
    if($type=='max'){
        $sql = "select max(`{$dbName}_sort`) from `" . $xoopsDB->prefix('kw_leave_' . $dbName) . "` where `{$dbName}_isenable` = 1 ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($sort) = $xoopsDB->fetchRow($result);
        return $sort;
    }else{
        $sql = "select max(`{$dbName}_sort`) from `" . $xoopsDB->prefix('kw_leave_' . $dbName) . "` ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($sort) = $xoopsDB->fetchRow($result);
        return ++$sort;
    }
}


//取得排序值
/**
 * @param $dbName
 * @return $sort[]
 */
function kw_leave_get_sort($dbname, $id)
{
    global $xoopsDB, $xoopsUser;
    if (empty($dbname) || empty($id)) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_ERROR);
        return;
    }
    $sql = "select `" . $dbname . "_sort` from `" .  $xoopsDB->prefix('kw_leave_' . $dbname) .  "` where  `" . $dbname . "_id`='{$id}' ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($sort) = $xoopsDB->fetchRow($result);

    return $sort;
}




//檢核假單簽核
/**
 * @param $sign_id
 * @param $isAgree
 * @param $sign_code
 * @return bool
 */
function kw_leave_chk_sign($sid,$isAgree)
{
    global $xoopsDB;

    //檢查資料
    if (empty($sid) or !isset($isAgree)) {
        return _MD_KWLEAVE_NEED_ID;
    }
    
    //檢查是否審核完畢 或 確認uid正確
    $sql = 'select `book_id`,`sign_uid`,`sign_time`,`sign_sort`,`sign_code` from `' . $xoopsDB->prefix('kw_leave_sign') . "`  where `sign_id` = '{$sid}'";
    $result = $xoopsDB->queryF($sql) or Utility::web_error($sql);
    list($book_id, $sign_uid, $time, $sign_sort, $sign_code) = $xoopsDB->fetchRow($result);
    if (!empty($time)  ) {
        return _MD_KWLEAVE_BOOK_ISCHECK; //已簽核
    }

    //取得家長email和老師uid資訊
    $sql = "select a.`book_title`, a.`book_dt_start`, a.`book_dt_end`, a.`book_json`, b.`sign_uid` from `" . $xoopsDB->prefix('kw_leave_book') . "` as a join `".$xoopsDB->prefix('kw_leave_sign') ."` as b where a.`book_id`= b.`book_id` and a.`book_id` = {$book_id} and b.`sign_sort`=0";
    $result = $xoopsDB->queryF($sql) or Utility::web_error($sql);
    list($book_title, $book_dt_start, $book_dt_end,$book_json, $teacher_uid, $sign_code) = $xoopsDB->fetchRow($result);
    $json_arr = json_decode($book_json,true);
    $json_email = $json_arr['stu_email']; //取得家長的mail

    //取得最後sort關卡數
    $max_sort = kw_leave_max_sort('process', 'max');
    if($isAgree == 1){ //同意
        //本人簽核同意時間
        $sql = 'update `' . $xoopsDB->prefix('kw_leave_sign') . "` set  `sign_time`=NOW() where `sign_id` = '{$sid}'";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);

        //確認是否已達最後關卡
        if($max_sort == $sign_sort){ //假單完成簽核程序
            $sql = 'update `' . $xoopsDB->prefix('kw_leave_book') . "` set `book_isfinish`= '1', `book_isresult`= '1' where `book_id` = '{$book_id}'";
            $xoopsDB->queryF($sql) or Utility::web_error($sql);
            
            //寄信通知家長和導師
            $book_arr = ['book_id'=>$book_id,'book_title'=>$book_title, 'dt_start'=>$book_dt_start, 'dt_end'=>$book_dt_end, 'parent_email'=>$json_email, 'sign_id'=>$sid,'sign_code'=>$sign_code,'uid'=>$teacher_uid, 'mail_order'=>'finished'];
            list($isMailToP,$msg_p) = Kw_leave_SendMail($book_arr,'parent');
            list($isMailToT,$msg_t) = Kw_leave_SendMail($book_arr,'teacher');
            return "審核成功!".$msg_p.$msg_t;

        }else{
            //更新流程+1 往下一關簽核   
            $sql = 'update `' . $xoopsDB->prefix('kw_leave_book') . "` set  `book_isfinish`= '0',`book_sort`=`book_sort`+1 where `book_id` = '{$book_id}'";
            $xoopsDB->queryF($sql) or Utility::web_error($sql);

            //取得下一關審核者資訊
            $next_sort=$sign_sort+1;
            $sql = "select `sign_id`,`sign_uid`,`sign_code` from `" . $xoopsDB->prefix('kw_leave_sign') . "` where `book_id`={$book_id} and `sign_sort`= {$next_sort}";
            $result = $xoopsDB->queryF($sql) or Utility::web_error($sql);
            list($next_sid, $next_uid, $next_code ) = $xoopsDB->fetchRow($result);

            //mail 通知下一關
            $book_arr = ['book_id'=>$book_id,'book_title'=>$book_title, 'dt_start'=>$book_dt_start, 'dt_end'=>$book_dt_end, 'parent_email'=>$json_email, 'sign_id'=>$next_sid, 'sign_code'=>$next_code,'sign_sort'=>$sign_sort, 'uid'=>$next_uid, 'mail_order'=>'master'];
            // die(var_dump($book_arr));
            list($isMail,$msg) = Kw_leave_SendMail($book_arr,'master');
            return "審核成功!".$msg;
        }
    }
    else if($isAgree == 0){//退回
        
        //簽核拒絕時間
        $sql = 'update `' . $xoopsDB->prefix('kw_leave_sign') . "` set  `sign_time`=NOW(), `sign_isagree`='0'  where `sign_id`='{$sid}'";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
        
        //更新學生請假日數
        $book_arr = Kw_leave::kw_leave_get_data('book',$book_id );
        $sql = 'update `'.$xoopsDB->prefix('kw_leave_stu')."` SET `stu_total`=`stu_total`-{$book_arr['book_number']} WHERE `stu_id` = '{$book_arr['stu_id']}' ";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);

        //假單結束
        $sql = 'update `' . $xoopsDB->prefix('kw_leave_book') . "` set `book_isfinish`= '1', `book_isresult`= '0' where `book_id`='{$book_id}'";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
        
        //發送mail通知家長和導師
        $book_arr = ['book_id'=>$book_id,'book_title'=>$book_title, 'dt_start'=>$book_dt_start, 'dt_end'=>$book_dt_end, 'parent_email'=>$json_email, 'sign_code'=>$sid,'sign_code'=>$sign_code,'sign_sort'=>$sign_sort, 'uid'=>$teacher_uid, 'mail_order'=>'return'];

        list($isMailP,$msg_p) = Kw_leave_SendMail($book_arr,'parent');
        list($isMailT,$msg_t) = Kw_leave_SendMail($book_arr,'teacher');

        return "審核成功!".$msg_p.$msg_t;
    }
    
}

//假單寄信通知
/**
 * @param $book_arr [] 信件內容相關資訊
 * @return $type 寄給身分{'parent','teacher','master'}
*/
function Kw_leave_SendMail($book_arr, $type){

    if(!$book_arr || empty($type) )
    {
        return [false,"參數錯誤!"];
    }else{
        if($type == 'parent'){ //發送mail通知家長
            if($book_arr['mail_order'] == 'start'){
                $title=$book_arr['book_title']."通知";
                $content="親愛的家長您好，您的子弟提出{$book_arr['dt_start']}-{$book_arr['dt_end']}請假，假單正在審核中!請耐心等待!請勿回覆此通知~" ;
            }
            else if($book_arr['mail_order'] == 'return'){
                $title=$book_arr['book_title']."退回通知";
                $content="親愛的家長您好，您的子弟提出{$book_arr['dt_start']}-{$book_arr['dt_end']}請假被退回，請修正再重新申請!請勿回覆此通知~";
            }
            else if($book_arr['mail_order'] == 'finished'){
                $title=$book_arr['book_title']."完成通知";
                $content="親愛的家長您好，您的子弟提出{$book_arr['dt_start']}-{$book_arr['dt_end']}請假手續已完成!請勿回覆此通知~";
            }
            list($isMail, $msg) = kw_leave_Email($book_arr['parent_email'], $title , $content);
        }
        if($type == 'teacher'){//發送mail通知導師
            if($book_arr['mail_order'] == 'start'){
                $title=$book_arr['book_title']."通知";
                $sign_url = "<a href='". XOOPS_URL ."/modules/kw_leave/save_sort.php?op=".urlencode('kw_leave_msign')."&code=".urlencode($book_arr['sign_code'])."&id=".urlencode($book_arr['sign_id'])."'>同意請假，並傳送下一關審核</a>";
                // die("code:".$book_arr['sign_code'].$sign_url);
                $content="您的班級學生提出{$book_arr['dt_start']}到{$book_arr['dt_end']}請假，請盡速到網站上簽核或是直接點選下列連結簽核!<br>{$sign_url}，如果不同意請假，請到網站上審核。請勿回覆此通知~";
            }else if($book_arr['mail_order'] == 'return'){
                $title=$book_arr['book_title']."退回通知";
                $content="您的班級學生提出{$book_arr['dt_start']}到{$book_arr['dt_end']}請假已被退回!請勿回覆此通知~";
            }
            else if($book_arr['mail_order'] == 'finished'){
                $title=$book_arr['book_title']."完成通知";
                $content="您的班級學生提出{$book_arr['dt_start']}到{$book_arr['dt_end']}請假，請假手續已完成!請勿回覆此通知~";
            }
            list($isMail, $msg) = kw_leave_sendEmail($book_arr['uid'], $title , $content);
        }
        
        if($type == 'master'){//發送mail通知行政簽核
            $title=$book_arr['book_title']."簽核通知";
            $sign_url = "<a href='". XOOPS_URL ."/modules/kw_leave/save_sort.php?op=".urlencode('kw_leave_msign')."&code=".urlencode($book_arr['sign_code'])."&id=".urlencode($book_arr['sign_id'])."'>同意請假，並傳送下一關審核</a>";
            $content="學生提出".$book_arr['dt_start']."到".$book_arr['dt_end']."請假，請盡速簽核!或是直接點選下列連結簽核<br>{$sign_url}，如果不同意請假，請到網站上審核。請勿回覆此通知~";
            list($isMail, $msg) = kw_leave_sendEmail($book_arr['uid'], $title , $content);
        }

        return [$isMail, $msg] ;
    }
}

//寄送內部人員信件
function kw_leave_sendEmail($uid = '', $title = '', $content = '')
{
    global $xoopsMailer, $xoopsConfig, $xoopsDB, $xoopsModuleConfig, $xoopsModule;
    if (empty($uid)) {
        return;
    }
    // $memberHandler = xoops_getHandler('member');
    // $user           = $memberHandler->getUser($uid);
    // $email          = $user->email();
    $msg="";
    $sql = 'select email from `' . $xoopsDB->prefix('users') . "` where uid='{$uid}'";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql, __FILE__, __LINE__);
    list($email) = $xoopsDB->fetchRow($result);

    $xoopsMailer = getMailer();
    $xoopsMailer->multimailer->ContentType = 'text/html';
    $xoopsMailer->addHeaders('MIME-Version: 1.0');
    $headers = '';
    $sendMail = $xoopsMailer->sendMail($email, $title, $content, $headers);
    $getErrors = $xoopsMailer->getErrors(true);

    $msg .= $sendMail ? sprintf(_MD_KWLEAVE_MAIL_OK, $title, "下一關審核") : sprintf(_MD_KWLEAVE_MAIL_FAIL, $title, $email) . $getErrors;

    return [$sendMail, $msg];

}

//寄送外部信件
function kw_leave_Email($email, $title = '', $content = '')
{
    global $xoopsMailer;
    if (empty($email)) {
        return [false, "E-mail不正確!"];
    }
    $msg="";
    $xoopsMailer = getMailer();
    $xoopsMailer->multimailer->ContentType = 'text/html';
    $xoopsMailer->addHeaders('MIME-Version: 1.0');
    $headers = '';
    $sendMail = $xoopsMailer->sendMail($email, $title, $content, $headers);
    $getErrors = $xoopsMailer->getErrors(true);
    $msg .= $sendMail ? sprintf(_MD_KWLEAVE_MAIL_OK, $title, "家長信箱".$email) : sprintf(_MD_KWLEAVE_MAIL_FAIL, $title, $email) . $getErrors;

    return [true, $msg];

}

// function SendEmail($uid = '', $title = '', $content = '')
// {
//     global $xoopsDB;
//     if (empty($uid)) {
//         return;
//     }

//     $sql = 'select `email` from `' . $xoopsDB->prefix('users') . "` where `uid`='{$uid}'";
//     $result = $xoopsDB->query($sql) or Utility::web_error($sql, __FILE__, __LINE__);
//     list($email) = $xoopsDB->fetchRow($result);

//     $xoopsMailer = getMailer();
//     $xoopsMailer->multimailer->ContentType = 'text/html';
//     $xoopsMailer->addHeaders('MIME-Version: 1.0');
//     $headers = '';
//     $sendMail = $xoopsMailer->sendMail($email, $title, $content, $headers);
//     $getErrors = $xoopsMailer->getErrors(true);

//     $msg .= $sendMail ? sprintf(_MD_TADREPAIR_MAIL_OK, $title, $email) : sprintf(_MD_TADREPAIR_MAIL_FAIL, $title, $email) . $getErrors;

//     return $msg;
// }


function kw_leave_spamCheck($field)
{
    // filter_var() 過濾 e-mail
    // 使用 FILTER_SANITIZE_EMAIL
    $field=filter_var($field, FILTER_SANITIZE_EMAIL);

    //filter_var() 過濾 e-mail
    // 使用 FILTER_VALIDATE_EMAIL
    if(filter_var($field, FILTER_VALIDATE_EMAIL))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

//取得亂數編碼
/**
 * @param length
 * @return mixed
 */
function kw_leave_getKey($length = 5)
{
    $Characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $QuantidadeCharacters = strlen($Characters);
    $QuantidadeCharacters--;
    $Hash = NULL;
    for ($x = 1; $x <= $length; $x++) {
        $Posicao = rand(0, $QuantidadeCharacters);
        $Hash .= substr($Characters, $Posicao, 1);
    }
    return $Hash;
}

//取得亂數英文字母
/**
 * @param length
 * @return mixed
 */
function kw_leave_verifyNumber($length=''){
    //隨機取得4個小寫英字a-z
    mt_srand((double)microtime() * 1000000);  //重置隨機值
    if(empty($length))
        $length = 4;
    $ans_now="";
    for($i=0; $i<$length; $i++){
        // $ans_str = $i%2==0?mt_rand(97,122):mt_rand(48,57);
        $ans_str = mt_rand(48,57);
        $ans_now .= chr($ans_str);
    }
    return $ans_now;
}

//產生隨機圖片
/**
 * @param none
 * @return png 
 */
function kw_leave_makePic(){
    $number = kw_leave_verifyNumber();
    $_SESSION['verify_num'] = $number;

    $s_x=0; $s_y=0; $ans_right_move='';  //變數初始化
    $width = 160;
    $height=40;
    // if(!isset($number))
    //     return false;
    $im = imagecreate($width, $height); //size
    // $red2 = imagecolorallocate($im,255,0,0);  //文字顏色
    $bgColor = imagecolorallocate($im,200,200,200);  //背影顏色
    imagefill($im,0,0,$bgColor);
    mt_srand((double)microtime() * 1000000);  //重置隨機值
    
    //隨機30點
    for($i=0; $i<30; $i++){
        $s_dot = imagecolorallocate($im,mt_rand(0,255),mt_rand(0,255),mt_rand(0,128));
        imagesetpixel($im,mt_rand(10,120),mt_rand(5,30),$s_dot);
    }
    //隨機畫3條線
    for($i=0; $i<3;$i++){
    $_rand_color = imagecolorallocate($im, mt_rand(0,255), mt_rand(0,255), mt_rand(0, 255));
    imageline($im,mt_rand(0,$width),mt_rand(0,$height),mt_rand(0,$width),mt_rand(0,$height),$_rand_color);

}
    //文字隨機浮動
    $s_x = mt_rand(5,50); //start range point
    for($i=0; $i<strlen($number); $i++){
        $_rand_color = imagecolorallocate($im, mt_rand(0,100), mt_rand(0,150), mt_rand(0, 200));
        $ans_right_move = substr($number,$i,1);
        $s_y = mt_rand(1,15);
        $font = imageloadfont('./assets/font/HomBoldB_16x24_LE.gdf');
        imagestring($im,$font,$s_x,$s_y,$ans_right_move,$_rand_color );
        // imagettftext($im, 12, 0, 200, 100, 0, 'consolas.ttf' , "thanks!");
        $s_x = $s_x + mt_rand(18,40);
    }

    //輸出圖片
    header('Content-type: image/png');
    imagepng($im);
    // $save = XOOPS_UPLOAD_PATH.'//kw_leave//verify.png';
    // imagepng($im, $save);
    imagedestroy($im);
}


//身份證字號檢核
/**
 * @param $cardid
 * @return bool
 */
function pid_check($cardid)
{
    $err='';
    //先將字母數字存成陣列
    $cardid = mb_strtoupper($cardid); //若輸入英文字母為小寫則轉大寫
    $alphabet = [
        'A' => '10',
        'B' => '11',
        'C' => '12',
        'D' => '13',
        'E' => '14',
        'F' => '15',
        'G' => '16',
        'H' => '17',
        'I' => '34',
        'J' => '18',
        'K' => '19',
        'L' => '20',
        'M' => '21',
        'N' => '22',
        'O' => '35',
        'P' => '23',
        'Q' => '24',
        'R' => '25',
        'S' => '26',
        'T' => '27',
        'U' => '28',
        'V' => '29',
        'W' => '32',
        'X' => '30',
        'Y' => '31',
        'Z' => '33',
    ];
    //檢查字元長度
    if (10 != mb_strlen(trim($cardid))) {
        return false;
    } //長度不對

    //驗證英文字母正確性
    $alpha = mb_substr($cardid, 0, 1); //英文字母
    if (!preg_match('/[A-Za-z]/', $alpha)) {
        return false;
    }
    //計算字母總和
    $nx = $alphabet[$alpha];
    $ns = $nx[0] + $nx[1] * 9; //十位數+個位數x9

    //驗證男女性別
    $gender = mb_substr($cardid, 1, 1); //取性別位置
    if ('1' != $gender && '2' != $gender && '8' != $gender && '9' != $gender && 'A' !== $gender && 'B' !== $gender && 'C' !== $gender && 'D' !== $gender) {
        return false;
    } 

    //N2x8+N3x7+N4x6+N5x5+N6x4+N7x3+N8x2+N9+N10
    if ('' == $err) {
        $i = 8;
        $j = 1;
        $ms = 0;
        //先算 N2x8 + N3x7 + N4x6 + N5x5 + N6x4 + N7x3 + N8x2
        while ($i >= 2) {
            if (1 == $j) {
                $g = mb_substr($cardid, $j, 1);
                switch ($g) {
                    case 'A':
                        $mx = 0;
                        break;
                    case 'B':
                        $mx = 1;
                        break;
                    case 'C':
                        $mx = 2;
                        break;
                    case 'D':
                        $mx = 3;
                        break;
                    default:
                        $mx = $g;
                        break;
                }
            } else {
                $mx = mb_substr($cardid, $j, 1); //由第j筆每次取一個數字
            }

            $my = $mx * $i; //N*$i
            $ms += $my; //ms為加總
            $j++;
            $i--;
        }
        //最後再加上 N9 及 N10
        $ms = $ms + mb_substr($cardid, 8, 1) + mb_substr($cardid, 9, 1);
        //最後驗證除10
        $total = $ns + $ms; //上方的英文數字總和 + N2~N10總和
        return (0 == $total % 10) ? true : false;
    }
}


function chk_pid($id) {
    if( !$id )return false;
    $id = strtoupper(trim($id)); //將英文字母全部轉成大寫，消除前後空白
    //檢查第一個字母是否為英文字，第二個字元1 2 A~D 其餘為數字共十碼
    $ereg_pattern= "^[A-Z]{1}[12ABCD]{1}[[:digit:]]{8}$";
    if(!ereg($ereg_pattern, $id)) return false;
    $wd_str="BAKJHGFEDCNMLVUTSRQPZWYX0000OI";   //關鍵在這行字串
    $d1=strpos($wd_str, $id[0])%10;
    $sum=0;
    if($id[1]>='A')$id[1]=ord($id[1])-65; //第2碼非數字轉換依[4]說明處理
    for($ii=1;$ii<9;$ii++)
        $sum+= (int)$id[$ii]*(9-$ii);
    $sum += $d1 + (int)$id[9];
    if($sum%10 != 0)return false;
    return true;
}


