<?php
/*-----------引入檔案區--------------*/
use Xmf\Request;
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Tadtools\Utility;
use XoopsModules\Tadtools\SweetAlert;
use XoopsModules\Tadtools\FormValidator;
use XoopsModules\Tadtools\CkEditor;
use XoopsModules\Tadtools\My97DatePicker;
require_once __DIR__ . '/header.php';
$xoopsOption['template_main'] = "kw_leave_teacher.tpl";
include_once XOOPS_ROOT_PATH . "/header.php";

/*-----------執行動作判斷區----------*/
require_once $GLOBALS['xoops']->path('/modules/system/include/functions.php');
$op        = Request::getString('op');
$id        = Request::getInt('id'); 
$stu_id    = Request::getString('stu_id');  
$class_id  = Request::getString('class_id'); 
$value     = Request::getString('value'); 
$today = date('Y-m-d');

//檢查權限
if (!$iskwLeaveAdmin && !$iskwLeaveCheck && !$iskwLeaveMaster  ) {
    redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_FORBBIDEN);
    return;
}

switch ($op) {

    case 'kw_leave_stu_search': //ajax search學生
        kw_leave_manerge_stu('search', $class_id, $stu_id);
        exit;
    
    case 'kw_leave_stu_move': //ajax add學生
        kw_leave_manerge_stu('move', $class_id, $stu_id);
        exit;

    case 'kw_leave_stu_add': //ajax add學生
        //XOOPS表單安全檢查
        if (!$GLOBALS['xoopsSecurity']->check()) 
            die(0);
        kw_leave_manerge_stu('add', $class_id, $stu_id);
        exit;

    case 'kw_leave_stu_delete':
        kw_leave_delete_stu($stu_id, $class_id);
        //接著跑kw_leave_teacher
    default:
        kw_leave_teacher($class_id);
        $op = 'kw_leave_teacher_list';
}

/*-----------秀出結果區--------------*/
$xoopsTpl->assign('op', $op);
$xoopsTpl->assign("toolbar", Utility::toolbar_bootstrap($interface_menu,false,$interface_icon));
$xoopsTpl->assign('today', $today);
$xoopsTpl->assign('uid', $kw_leave_uid);
$xoopsTpl->assign('iskwLeaveAdmin', $iskwLeaveAdmin);
$xoopsTpl->assign('iskwLeaveCheck', $iskwLeaveCheck);
$xoopsTpl->assign('iskwLeaveMaster', $iskwLeaveMaster);
$xoTheme->addStylesheet(XOOPS_URL . '/modules/kw_leave/assets/css/module.css');
$xoTheme->addStylesheet(XOOPS_URL . '/modules/tadtools/css/vtable.css');
require_once XOOPS_ROOT_PATH . '/footer.php';

function kw_leave_teacher($class_id)
{
    global $iskwLeaveCheck, $iskwLeaveAdmin,$iskwLeaveMaster, $kw_leave_uid;
    global $xoopsDB, $xoopsTpl,$xoopsUser,$school_grade,$school_class;
    //判斷權限
    if($iskwLeaveCheck || $iskwLeaveAdmin){ //行政人員 管理者
        $class_arr = Kw_leave::kw_leave_get_data('class');
        $xoopsTpl->assign('class_arr',$class_arr);
        $job ="行政人員";
        if(isset($class_id)){
            $xoopsTpl->assign('class_id',$class_id);
            $sql = 'SELECT * FROM `' . $xoopsDB->prefix('kw_leave_stu') ."` WHERE `class_id`='{$class_id}' order by `stu_num`";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            // echo $sql;
        }
    }
    else if($iskwLeaveMaster){ //導師
        $myClass = Kw_leave::kw_leave_get_dataByUid($kw_leave_uid,'teacher');
        $class_id = $myClass['class_id'];
        $xoopsTpl->assign('class_id', $class_id);
        $class_arr[$class_id] = $myClass;
        $xoopsTpl->assign('class_arr', $class_arr);
        $job = $myClass['class_title'];
        $sql = "SELECT * FROM `" . $xoopsDB->prefix('kw_leave_stu') ."` WHERE `class_id`='{$class_id}' order by `stu_num`";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    }else{

    }
    $xoopsTpl->assign('job', $job); 
    //取得其他資訊
    $myName = $xoopsUser->name();
    $xoopsTpl->assign('myName', $myName);
    $semester_arr = kw_leave_getSemester();
    $xoopsTpl->assign('semester_arr', $semester_arr);

    $class_opt = json_encode($school_class, 256);
    $class_opt = mb_substr(str_replace('"', "'", $class_opt), 1, -1);

    //js套件
    include_once XOOPS_ROOT_PATH."/modules/tadtools/jeditable.php";
    $jeditable = new jeditable();
    $file = 'save_sort.php';
    //功能範例
    // $jeditable->setTextCol("#id",$file,'140px','12px',"{'stu_id':$stu_id,'op':'update_kw_leave__stuupdate'}","點擊編輯");
    // $jeditable->setTextAreaCol("#id",$file,'140px','12px',"{'sn':$sn,'op' : 'save'}","點擊編輯");
    // $jeditable->setSelectCol("#id",$file,"{'boy':'男生' , 'girl':'女生' , 'selected':'girl'}","{'sn' : $sn , 'op' : 'save'}","點擊編輯");
    // $jeditable_set=$jeditable->render();
    

    $all_stu = [];
    while (false !== ($all = $xoopsDB->fetchArray($result))) {
        foreach ($all as $k => $v) {
            $$k = $v; 
        }
        $all_stu[$stu_id] = $all;
        $jeditable->setTextCol("#stu_title_{$stu_id}", $file, '100px', '1em', "{stu_id: {$stu_id} ,op:'kw_leave_stu_update'}", _MD_KWLEAVE_CLICK_TO_EDIT);
        $jeditable->setTextCol("#stu_uid_{$stu_id}", $file, '100px', '1em', "{stu_id: {$stu_id} ,op:'kw_leave_stu_update'}", _MD_KWLEAVE_CLICK_TO_EDIT);
        // $jeditable->setSelectCol("#stu_grade_{$all['stu_id']}", $file, "{ $school_grade , 'selected':'{$all['stu_grade']}'}", "{stu_id: {$all['stu_id']} ,op:'kw_leave_stu_update'}", _MD_KWLEAVE_CLICK_TO_EDIT);
        $jeditable->setSelectCol("#stu_class_{$stu_id}", $file, "{ $class_opt , 'selected':'{$stu_class}'}", "{stu_id: {$stu_id} ,op:'kw_leave_stu_update', grade:'{$stu_grade}'}", _MD_KWLEAVE_CLICK_TO_EDIT);
        $jeditable->setTextCol("#stu_num_{$stu_id}", $file, '60px', '1em', "{stu_id: {$stu_id} ,op:'kw_leave_stu_update'}", _MD_KWLEAVE_CLICK_TO_EDIT);
        
    }
    $jeditable->render();
    $xoopsTpl->assign('all_stu', $all_stu);

    if (!file_exists(XOOPS_ROOT_PATH . '/modules/tadtools/sweet_alert.php'))
        redirect_header('teacher.php', 3, _MD_NEED_TADTOOLS);
    else
        require_once XOOPS_ROOT_PATH . '/modules/tadtools/sweet_alert.php'; 
    $sweet_alert_obj = new sweet_alert();
    $sweet_alert_obj->render('delete_stu_func', "{$_SERVER['PHP_SELF']}?op=kw_leave_stu_delete&class_id={$class_id}&stu_id=", 'stu_id');

    //加入Token安全機制
    require_once XOOPS_ROOT_PATH . '/class/xoopsformloader.php';
    $token      = new \XoopsFormHiddenToken();
    $token_form = $token->render();
    $xoopsTpl->assign('new_stu_token', $token_form);

    //套用formValidator驗證機制
    $formValidator = new FormValidator('.stu-form', true);
    $formValidator->render();
}


function kw_leave_delete_stu($stu_id, $class_id){
    global $xoopsDB, $iskwLeaveMaster,$kw_leave_uid ;
    
    //導師只能刪本班學生
    if ($iskwLeaveMaster && isset($class_id)) {
        $sql = 'select `class_teacher_uid` from `' . $xoopsDB->prefix('kw_leave_class') . "` where `class_id`='{$class_id}'; ";
        $result = $xoopsDB->queryF($sql) or Utility::web_error($sql);
        list($teacher_uid) = $xoopsDB->fetchRow($result);
        if($kw_leave_uid !=  $teacher_uid ){
            redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_FORBBIDEN);
            exit;
        }
    }

    //檢查參數
    if (empty($stu_id) || empty($class_id)) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWLEAVE_NEED_ID);
        exit;
    } else {
        $sql = 'delete from `' . $xoopsDB->prefix('kw_leave_stu') . "` where `stu_id`='{$stu_id}'; ";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
    }
}

function kw_leave_manerge_stu($type, $class_id, $stu_id){
    global $xoopsDB,$school_grade,$school_class ;

    if(empty($type)|| empty($class_id) || empty($stu_id)){
        die('0');
    }
    if (strlen($class_id)==1){
        $grade= 0; 
        $class= $class_id;
    }else{
        $grade= (int) substr($class_id,0,1); 
        $class= (int) substr($class_id,1,2); 
    }

    //check stu
    if($type=='add'){
        $myts = \MyTextSanitizer::getInstance();
        $stu_title  = Request::getString('title');  
        $stu_uid    = Request::getString('sid'); 
        $stu_num    = Request::getInt('num');
        $stu_title = $myts->addSlashes($stu_title); 
        if(empty($stu_title ) || empty($stu_uid) ||empty($stu_num))
            die(0);
        // if(chk_pid($stu_id) /*pid_check($stu_uid)*/)
        //     die(2);
        $semester_arr = kw_leave_getSemester();
        $year= ($grade==0) ? $semester_arr['this_year'] : $semester_arr['this_year']- $grade + 1;
        $sql = 'SELECT * FROM `' . $xoopsDB->prefix('kw_leave_stu') ."` WHERE `stu_id`='{$stu_id}' OR `stu_uid`='{$stu_uid}'";
    }else
        $sql = 'SELECT * FROM `' . $xoopsDB->prefix('kw_leave_stu') ."` WHERE `stu_id`='{$stu_id}'";
    
    $stu =  $xoopsDB->fetchArray($xoopsDB->query($sql));
    if(empty($stu)){
        switch ($type){
            case 'search':
                die('錯誤，沒有此學生請重新查詢!');
            case 'move':
                die('0');
            case 'add':
                $sql = 'INSERT INTO `'.$xoopsDB->prefix('kw_leave_stu')."` (`stu_id`, `class_id`, `stu_title`,`stu_num`,`stu_uid`,`stu_year`,`stu_grade`,`stu_class`,`stu_total`)  VALUE ( '{$stu_id}','{$class_id}','{$stu_title}','{$stu_num}','{$stu_uid}','{$year}','{$grade}','{$class}','0')";
                $xoopsDB->queryF($sql) ;
                die('1');
        }
    }else if($stu['class_id'] == (int) $class_id){
        switch ($type){
            case 'search':
                die("{$stu['stu_num']}{$stu['stu_title']}({$stu['stu_id']})此學生已在班級中!!");
            case 'move':
                die('0');
            case 'add':
                die('0');
        }
    }else if($stu['stu_grade']!= $grade){
        switch ($type){
            case 'search':
                die("{$school_grade[$stu['stu_grade']]}年{$school_class[$stu['stu_class']]} {$stu['stu_num']}號 {$stu['stu_title']}({$stu['stu_id']})不同年級，無法新增");
            case 'move':
                die('0');
            case 'add':
                die('0');
        }
    }else{
        switch ($type){
            case 'search':
                die("{$school_grade[$stu['stu_grade']]}年{$school_class[$stu['stu_class']]} {$stu['stu_num']}號 {$stu['stu_title']}({$stu['stu_id']})");
            case 'move':
                $sql = 'UPDATE `' . $xoopsDB->prefix('kw_leave_stu') ."` SET `class_id`='{$class_id}', `stu_class`='{$class}'  WHERE `stu_id`='{$stu_id}'";
                $xoopsDB->queryF($sql);
                die('1');
            case 'add':
                die('2'); //stu_id or stu_uid repeate
        }
    } //ajax
        
}//end function