<!--套用formValidator驗證機制-->
<form action="config.php" method="post" id="cateForm" enctype="multipart/form-data" class="myForm " role="form">
    <!--類型標題-->
    <div class="form-group row mb-3">
        <label class="col-sm-4 col-form-label text-sm-right  text-sm-end">
            <{$smarty.const._MD_KWLEAVE_CATE_TITLE}>
        </label>
        <div class="col-sm-6">
            <input type="text" name="cate_title" id="cate_title" class="form-control validate[required]" value="<{$cate_title}>" placeholder="<{$smarty.const._MD_KWLEAVE_CATE_TITLE}>">
        </div>
    </div>

    <!--類型排序-->
    <div class="form-group row mb-3">
        <label class="col-sm-4 col-form-label text-sm-right  text-sm-end">
            <{$smarty.const._MD_KWLEAVE_SORT}>
        </label>
        <div class="col-sm-6">
            <input type="text" name="cate_sort" id="cate_sort" class="form-control validate[required]" value="<{$cate_sort}>" placeholder="<{$smarty.const._MD_KWLEAVE_SORT}>">
        </div>
    </div>
    <!--狀態-->
    <div class="form-group row mb-3">
        <label class="col-sm-4 col-form-label text-sm-right  text-sm-end">
            <{$smarty.const._MD_KWLEAVE_ISENABLE}>
        </label>
        <div class="col-sm-6">
            <div class="form-check-inline radio-inline pt-2">
                <label class="form-check-label">
                    <input type="radio" name="cate_isenable" id="cate_isenable_1" value="1" <{if $cate_isenable != "0"}>checked<{/if}>>
                        <{$smarty.const._YES}>
                </label>
            </div>
            <div class="form-check-inline radio-inline pt-2">
                <label class="form-check-label">
                    <input type="radio" name="cate_isenable" id="cate_isenable_0" value="0" <{if $cate_isenable == "0"}>checked<{/if}>>
                        <{$smarty.const._NO}>
                </label>
                <{$cate_token}>
                <input type="hidden" name="type" value="cate">
                <input type="hidden" name="op" value="<{$_op}>">
                <input type="hidden" name="config_id" value="<{$cate_id}>">
                <button type="submit" class="btn btn-primary text-end text-right"><{$smarty.const._TAD_SAVE}></button>
                
            </div>
        </div>
    </div>
   
    
</form>

<!--類型排序-->
<form action="config.php" method="post" id="dateForm" enctype="multipart/form-data" class="myForm " role="form">
    <h4>特殊日期設定</h4>
<div class="input-group mb-3">
    <input class="form-control validate[required]" type="text" name="rest_date" id="rest_date"  onclick="WdatePicker({dateFmt:'MM-dd'})" required="required" pattern="\d{2}-\d{2}" />
    <button type="button" id="add_rest" class="btn btn-danger btn-sm">新增假日</button>

    <input class="form-control validate[required]" type="text" name="work_date" id="work_date"  onclick="WdatePicker({dateFmt:'MM-dd'})" required="required" pattern="\d{2}-\d{2}" />
    <!-- <input name="work_date" class="form-control" type="date" min="01-01" max="01-01" required="required" pattern="\d{2}-\d{2}" /> -->
    <button type="button" id="add_work" class="btn btn-success btn-sm text-center" >新增工作日</button>
</div>
<div class="row">
    <div class="col input-group ">
        <span class="input-group-text">放假日</span>
        <select multiple class="form-control form-select form-select-sm" id="date-rest" multiple aria-label="multiple select ">
            <{foreach from=$restDate_arr item=rest}>
            <option value="<{$rest}>"><{$rest}></option>
            <{/foreach}>
        </select>
    </div>
    <div class="col input-group ">
        <span class="input-group-text" >工作日</span>
        <select multiple class="form-control form-select form-select-sm" id="date-work" multiple aria-label="multiple select ">
            <{foreach from=$workDate_arr item=work}>
            <option value="<{$work}>"><{$work}></option>
            <{/foreach}>
        </select>
    </div>
</div>
<p>雙擊日期即可刪除。</p>
</form>


<script>
$(document).ready(function(){

    $("#add_rest").click(function(){
        let date = $("#rest_date").val();
        if(date=='') {
            swal("錯誤","沒有選擇日期","error");
            return;
        } 
        $.get("config.php", {op: "kw_leave_config_date_add" , type:"rest", tab:'2', date: date}, function(res){
            $("#date-rest").append('<option value=>'+date+'</option>');
            $("#rest_date").val(""); 
            swal("結果",res,"success");
        });
    });

    $("#date-rest").dblclick(function(){
        let date = $("#date-rest option:selected").val();
        if(date=='') {
            swal("錯誤","沒有日期","error");
            return;
        } 
        $.get("config.php", {op: "kw_leave_config_date_del" , type:"rest", tab:'2', date: date}, function(res){
            $('#date-rest option:selected').remove();
            swal("結果",res,"success");
            setTimeout(function(){ 
                location.reload();
            }, 1000);  
        });
    });

    $("#add_work").click(function(){
        let date = $("#work_date").val();
        if(date=='') {
            swal("錯誤","沒有選擇日期","error");
            return;
        } 
        $.get("config.php", {op: "kw_leave_config_date_add" , type:"work", tab:'2', date: date}, function(res){
            $("#date-work").append('<option value=>'+date+'</option>');
            $("#work_date").val(""); 
            swal("結果",res,"success");
        });
    });

    $("#date-work").dblclick(function(){
        let date = $("#date-work option:selected").val();
        if(date=='') {
            swal("錯誤","沒有日期","error");
            return;
        } 
        $.get("config.php", {op: "kw_leave_config_date_del" , type:"work", tab:'2', date: date}, function(res){
            $('#date-work option:selected').remove();
            swal("結果",res,"success");
            setTimeout(function(){ 
                location.reload();
            }, 1000);  
        });
    });

});
</script>