<?php
$modversion = array();

//---模組基本資訊---//
$modversion['name']        = '學生請假系統';
$modversion['version']     = 1.1;
$modversion['description'] = '模組說明';
$modversion['author']      = 'kawaki';
$modversion['credits']     = 'kawaki';
$modversion['help']        = 'page=help';
$modversion['license']     = 'GNU GPL 2.0';
$modversion['license_url'] = 'www.gnu.org/licenses/gpl-2.0.html/';
$modversion['image']       = 'images/logo.png';
$modversion['dirname']     = basename(dirname(__FILE__));

//---模組狀態資訊---//
$modversion['release_date']        = '2024/3/28';
$modversion['module_website_url']  = 'https://github.com/laecych/kw_leave';
$modversion['module_website_name'] = '學生請假系統';
$modversion['module_status']       = 'release';
$modversion['author_website_url']  = 'https://github.com/laecych/kw_leave';
$modversion['author_website_name'] = 'laecych的程式';
$modversion['min_php']             = 7.0;
$modversion['min_xoops']           = '2.5.9';

//---paypal資訊---//
$modversion['paypal']                  = array();
$modversion['paypal']['business']      = 'kawaki@gmail.com';
$modversion['paypal']['item_name']     = 'Donation : ' . '贊助對象名稱';
$modversion['paypal']['amount']        = 0;
$modversion['paypal']['currency_code'] = 'USD';

//---安裝設定---//
$modversion['onInstall']   = "include/onInstall.php";
$modversion['onUpdate'] = "include/onUpdate.php";
$modversion['onUninstall'] = "include/onUninstall.php";

//---後台使用系統選單---//
$modversion['system_menu'] = 1;

//---模組資料表架構---//
$modversion['sqlfile']['mysql'] = 'sql/mysql.sql';
$modversion['tables'][0] = 'kw_leave_office';
$modversion['tables'][1] = "kw_leave_cate";
$modversion['tables'][2] = "kw_leave_process";
$modversion['tables'][3] = "kw_leave_sign";
$modversion['tables'][4] = "kw_leave_img";
$modversion['tables'][5] = "kw_leave_book";
$modversion['tables'][6] = "kw_leave_class";
$modversion['tables'][7] = "kw_leave_stu";


//---後台管理介面設定---//
$modversion['hasAdmin']   = 0;
$modversion['adminindex'] = 'admin/index.php';
$modversion['adminmenu']  = 'admin/menu.php';

//---前台主選單設定---//
$modversion['hasMain'] = 1;
$i = 1;
$modversion['sub'][$i]['name'] = _MI_KWLEAVE_SMNAME1; //請假介面
$modversion['sub'][$i]['url'] = 'index.php';
$i++;

$modversion['sub'][$i]['name'] = _MI_KWLEAVE_SMNAME2; //流程介面
$modversion['sub'][$i]['url'] = 'book.php';
$i++;

$modversion['sub'][$i]['name'] = _MI_KWLEAVE_SMNAME3; //出席統計
$modversion['sub'][$i]['url'] = 'statistic.php';
$i++;

$modversion['sub'][$i]['name'] = _MI_KWLEAVE_SMNAME4; //學生管理
$modversion['sub'][$i]['url'] = 'teacher.php';
$i++;

$modversion['sub'][$i]['name'] = _MI_KWLEAVE_SMNAME5; //假單審核
$modversion['sub'][$i]['url'] = 'sign.php';
$i++;

$modversion['sub'][$i]['name'] = _MI_KWLEAVE_SMNAME6; //管理設定
$modversion['sub'][$i]['url'] = 'config.php';
$i++;


//---模組自動功能---//
//$modversion['onInstall'] = "include/install.php";
//$modversion['onUpdate'] = "include/update.php";
//$modversion['onUninstall'] = "include/onUninstall.php";

//---樣板設定---//
$modversion['templates']                    = array();
$i                                          = 1;
$modversion['templates'][$i]['file']        = 'kw_leave_index.tpl';
$modversion['templates'][$i]['description'] = 'kw_leave_index.tpl';

$i++;
$modversion['templates'][$i]['file']        = 'kw_leave_book.tpl';
$modversion['templates'][$i]['description'] = 'kw_leave_book.tpl';

$i++;
$modversion['templates'][$i]['file']        = 'kw_leave_statistic.tpl';
$modversion['templates'][$i]['description'] = 'kw_leave_statistic.tpl';

$i++;
$modversion['templates'][$i]['file']        = 'kw_leave_teacher.tpl';
$modversion['templates'][$i]['description'] = 'kw_leave_teacher.tpl';

$i++;
$modversion['templates'][$i]['file']        = 'kw_leave_sign.tpl';
$modversion['templates'][$i]['description'] = 'kw_leave_sign.tpl';

$i++;
$modversion['templates'][$i]['file']        = 'kw_leave_config.tpl';
$modversion['templates'][$i]['description'] = 'kw_leave_config.tpl';

//---偏好設定---//
// $modversion['config'] = array();
//偏好設定 自訂年級
$modversion['config'][] = [
  'name' => 'school_grade',
  'title' => '_MI_KWLEAVE_SCHOOL_GRADE',
  'description' => '_MI_KWLEAVE_SCHOOL_GRADE_DESC',
  'formtype' => 'select_multi',
  'valuetype' => 'array',
  'default' => [_MI_KWLEAVE_SCHOOL_GV0, _MI_KWLEAVE_SCHOOL_GV1, _MI_KWLEAVE_SCHOOL_GV2, _MI_KWLEAVE_SCHOOL_GV3, _MI_KWLEAVE_SCHOOL_GV4, _MI_KWLEAVE_SCHOOL_GV5, _MI_KWLEAVE_SCHOOL_GV6],
  'options' => [
      _MI_KWLEAVE_SCHOOL_GK0 => _MI_KWLEAVE_SCHOOL_GV0,
      _MI_KWLEAVE_SCHOOL_GK1 => _MI_KWLEAVE_SCHOOL_GV1,
      _MI_KWLEAVE_SCHOOL_GK2 => _MI_KWLEAVE_SCHOOL_GV2,
      _MI_KWLEAVE_SCHOOL_GK3 => _MI_KWLEAVE_SCHOOL_GV3,
      _MI_KWLEAVE_SCHOOL_GK4 => _MI_KWLEAVE_SCHOOL_GV4,
      _MI_KWLEAVE_SCHOOL_GK5 => _MI_KWLEAVE_SCHOOL_GV5,
      _MI_KWLEAVE_SCHOOL_GK6 => _MI_KWLEAVE_SCHOOL_GV6,
      _MI_KWLEAVE_SCHOOL_GK7 => _MI_KWLEAVE_SCHOOL_GV7,
      _MI_KWLEAVE_SCHOOL_GK8 => _MI_KWLEAVE_SCHOOL_GV8,
      _MI_KWLEAVE_SCHOOL_GK9 => _MI_KWLEAVE_SCHOOL_GV9,
      _MI_KWLEAVE_SCHOOL_GK10 => _MI_KWLEAVE_SCHOOL_GV10,
      _MI_KWLEAVE_SCHOOL_GK11 => _MI_KWLEAVE_SCHOOL_GV11,
      _MI_KWLEAVE_SCHOOL_GK12 => _MI_KWLEAVE_SCHOOL_GV12,
  ],
];

//偏好設定 自訂班級
$modversion['config'][] = [
  'name' => 'school_class',
  'title' => '_MI_KWLEAVE_SCHOOL_CLASS',
  'description' => '_MI_KWLEAVE_SCHOOL_CLASS_DESC',
  'formtype' => 'textbox',
  'valuetype' => 'text',
  'default' => _MI_KWLEAVE_SCHOOL_CLASS_DEFAULT
];

//偏好設定 學生登入方式
$modversion['config'][] = [
  'name' => 'stu_login',
  'title' => '_MI_KWLEAVE_STU_LOGIN',
  'description' => '_MI_KWLEAVE_STU_LOGIN_DESC',
  'formtype' => 'yesno',
  // 'valuetype' => 'int'
  'default' => 0
  // 'options' => [ 1=>1,0=>0 ]
];

//偏好設定 自訂班級
$modversion['config'][] = [
  'name' => 'school_code',
  'title' => '_MI_KWLEAVE_SCHOOL_CODE',
  'description' => '_MI_KWLEAVE_SCHOOL_CODE_DESC',
  'formtype' => 'textbox',
  'valuetype' => 'text',
  'default' => ''
];


//偏好設定 自訂請假起訖時間
$modversion['config'][] = [
  'name' => 'school_limit',
  'title' => '_MI_KWLEAVE_SCHOOL_LIMIT',
  'description' => '_MI_KWLEAVE_SCHOOL_LIMIT_DESC',
  'formtype' => 'textbox',
  'valuetype' => 'text',
  'default' => _MI_KWLEAVE_SCHOOL_LIMIT_DEFAULT
];

//偏好設定 自訂警告說明
$modversion['config'][] = [
  'name' => 'book_warning',
  'title' => '_MI_KWLEAVE_BOOK_WARNING',
  'description' => '_MI_KWLEAVE_BOOK_WARNING_DESC',
  'formtype' => 'textbox',
  'valuetype' => 'text',
  'default' => _MI_KWLEAVE_BOOK_WARNING_DESC
];

//偏好設定 自訂節數範圍
$modversion['config'][] = [
  'name' => 'school_time',
  'title' => '_MI_KWLEAVE_SCHOOL_TIME',
  'description' => '_MI_KWLEAVE_SCHOOL_TIME_DESC',
  'formtype' => 'select_multi',
  'valuetype' => 'array',
  'default' => [_MI_KWLEAVE_SCHOOL_TV1, _MI_KWLEAVE_SCHOOL_TV2, _MI_KWLEAVE_SCHOOL_TV3, _MI_KWLEAVE_SCHOOL_TV4, _MI_KWLEAVE_SCHOOL_TV5, _MI_KWLEAVE_SCHOOL_TV6,_MI_KWLEAVE_SCHOOL_TV7,_MI_KWLEAVE_SCHOOL_TV8 ],
  'options' => [
      _MI_KWLEAVE_SCHOOL_TK0 => _MI_KWLEAVE_SCHOOL_TV0,
      _MI_KWLEAVE_SCHOOL_TK1 => _MI_KWLEAVE_SCHOOL_TV1,
      _MI_KWLEAVE_SCHOOL_TK2 => _MI_KWLEAVE_SCHOOL_TV2,
      _MI_KWLEAVE_SCHOOL_TK3 => _MI_KWLEAVE_SCHOOL_TV3,
      _MI_KWLEAVE_SCHOOL_TK4 => _MI_KWLEAVE_SCHOOL_TV4,
      _MI_KWLEAVE_SCHOOL_TK5 => _MI_KWLEAVE_SCHOOL_TV5,
      _MI_KWLEAVE_SCHOOL_TK6 => _MI_KWLEAVE_SCHOOL_TV6,
      _MI_KWLEAVE_SCHOOL_TK7 => _MI_KWLEAVE_SCHOOL_TV7,
      _MI_KWLEAVE_SCHOOL_TK8 => _MI_KWLEAVE_SCHOOL_TV8,
      _MI_KWLEAVE_SCHOOL_TK9 => _MI_KWLEAVE_SCHOOL_TV9,
      _MI_KWLEAVE_SCHOOL_TK10 => _MI_KWLEAVE_SCHOOL_TV10,
      _MI_KWLEAVE_SCHOOL_TK11 => _MI_KWLEAVE_SCHOOL_TV11,
      _MI_KWLEAVE_SCHOOL_TK12 => _MI_KWLEAVE_SCHOOL_TV12
  ]
];
// $i = 0;
// $modversion['config'][$i]['name'] = 'kw_leave_book_group';
// $modversion['config'][$i]['title'] = '_MI_KWLEAVE_BOOKING_GROUP';
// $modversion['config'][$i]['description'] = '_MI_KWLEAVE_BOOKING_GROUP_DESC';
// $modversion['config'][$i]['formtype'] = 'group_multi';
// $modversion['config'][$i]['valuetype'] = 'array';
// $modversion['config'][$i]['default'] = '1';
// ++$i;
// $modversion['config'][$i]['name'] = 'kw_leave_max_book_period';
// $modversion['config'][$i]['title'] = '_MI_KWLEAVE_MAX_BOOKINGWEEK';
// $modversion['config'][$i]['description'] = '_MI_KWLEAVE_MAX_BOOKINGWEEK_DESC';
// $modversion['config'][$i]['formtype'] = 'textbox';
// $modversion['config'][$i]['valuetype'] = 'int';
// $modversion['config'][$i]['default'] = '4';



//$i=0;
//$modversion['config'][$i]['name']    = '偏好設定名稱（英文）';
//$modversion['config'][$i]['title']    = '偏好設定標題（常數）';
//$modversion['config'][$i]['description']    = '偏好設定說明（常數）';
//$modversion['config'][$i]['formtype']    = '輸入表單類型';
//$modversion['config'][$i]['valuetype']    = '輸入值類型';
//$modversion['config'][$i]['default']    = 預設值;
//
//$i++;

//---搜尋---//
$modversion['hasSearch'] = 1;
$modversion['search']['file'] = "include/search.php";
$modversion['search']['func'] = "搜尋函數名稱";


//---區塊設定---//
$modversion['blocks'][] = [
  'file' => 'kw_leave_block.php',
  'name' => _MI_KWLEAVE_BLOCK_NAME,
  'description' => _MI_KWLEAVE_BLOCK_DESC,
  'show_func' => 'kw_leave_block',
  'template' => 'kw_leave_block.tpl',
];

//$modversion['blocks'] = array();
//$i=1;
//$modversion['blocks'][$i]['file'] = "kw_leave_block.php";
//$modversion['blocks'][$i]['name'] = 學生請假申請;
//$modversion['blocks'][$i]['description'] = 學生請假申請系統，需登入申請;
//$modversion['blocks'][$i]['show_func'] = "kw_leave_book";
//$modversion['blocks'][$i]['template'] = "kw_leave_block.tpl";
//$modversion['blocks'][$i]['edit_func'] = "kw_leave_book_edit";
//$modversion['blocks'][$i]['options'] = "設定值1|設定值2";
//
//$i++;

//---評論---//
//$modversion['hasComments'] = 1;
//$modversion['comments']['pageName'] = '單一頁面.php';
//$modversion['comments']['itemName'] = '主編號';

//---通知---//
$modversion['hasNotification'] = 0;
